'shorter engine and sound related events activated by keyboard
    
    if key_exit = true then
        select case as const engine
        case 2'exit
            select case as const i_menu
            case 0'exit
                engine = 0
            case else'back to menu
                i_menu = 0
                i_menu_cur_pos = 0
                playsnd(snd_escape)
            end select
        case 10'goto menu
            engine = 2
            playsnd(snd_escape)
        case 11'close bagpack
            engine = 10
        case 20'goto menu
            engine = 2
            playsnd(snd_escape)
        case 30'exit editor
            initscreen()
            world_x = 0'bug prevention
            engine = 2
            playsnd(snd_escape)
        case 31'exit editor to loadmap
            data_CSV_write()
            data_MAP_write()
            engine = 30
        case 40'return to map editor
            pausstr()
            engine = 31
        case 41'return to tile editor
            engine = 40
        case 42'return to tile editor
            engine = 40
        end select
    endif
    
    if key_enter = true then
        select case as const engine
        case 2'select menu
            playsnd(snd_menu_enter)
            sleep 600,1'bug preventing - sound stops too early
        case 11'move items
            playsnd(snd_item)
        end select
    endif
    
    if key_back = true then
        select case as const engine
        case 10'open bagpack
            if draw_msg = false then
                engine = 11
                playsnd(snd_backspace)
            endif
        case 11'close bagpack
            engine = 10
            playsnd(snd_backspace)
        case 31'open object editor
            engine = 40
        case 40'close object editor
            pausstr()
            engine = 31
        end select
    endif
    
    if key_down = true then
        select case as const engine
        case 2'menu scroll down
            i_menu_cur_pos = i_menu_cur_pos + 1
            playsnd(snd_menu_scroll)
        case 10
            'move backward
            if draw_msg = false then
                select case as const pl_view
                case 1:if data_block(map(x,y+1)) <> 1 then pl_move = 2
                case 2:if data_block(map(x-1,y)) <> 1 then pl_move = 2
                case 3:if data_block(map(x,y-1)) <> 1 then pl_move = 2
                case 4:if data_block(map(x+1,y)) <> 1 then pl_move = 2
                end select
            'choice
            else
                if choice = 1 then
                    choice = 2
                elseif choice = 2 then
                    choice = 1
                endif
            endif
        case 11'scroll items
            itm_y = itm_y + 1
        case 20'walk down
            if draw_msg = false then
                if map(x,y+1) <> 0 then y = y + 1
            endif
        case 30, 31'scroll down
            ed_pos_y = ed_pos_y - 1
        end select
    endif
    
    if key_up = true then
        select case as const engine
        case 2'menu scroll up
            i_menu_cur_pos = i_menu_cur_pos - 1
            playsnd(snd_menu_scroll)
        case 10
            'move foreward
            if draw_msg = false then
                select case as const pl_view
                case 1:if data_block(map(x,y-1)) <> 1 then pl_move = 1
                case 2:if data_block(map(x+1,y)) <> 1 then pl_move = 1
                case 3:if data_block(map(x,y+1)) <> 1 then pl_move = 1
                case 4:if data_block(map(x-1,y)) <> 1 then pl_move = 1
                end select
            'choice
            else
                if choice = 1 then
                    choice = 2
                elseif choice = 2 then
                    choice = 1
                endif
            endif
        case 11'scroll items
            itm_y = itm_y - 1
        case 20'walk up
            if draw_msg = false then
                if map(x,y-1) <> 0 then y = y - 1
            endif
        case 30, 31'scroll up
            ed_pos_y = ed_pos_y + 1
        end select
    endif
    
    if key_left = true then
        select case as const engine
        case 2'back to menu
            i_menu = 0
            playsnd(snd_escape)
        case 10'turn left
            if draw_msg = false then
                pl_view = pl_view - 1
            endif
        case 11'scroll items
            itm_x = itm_x - 1
        case 20'walk left
            if draw_msg = false then
                if map(x-1,y) <> 0 then x = x - 1
            endif
        case 30, 31'scroll left
            ed_pos_x = ed_pos_x + 1
        end select
    endif
    
    if key_right = true then
        select case as const engine
        case 2'back to menu
            i_menu = 0
            playsnd(snd_escape)
        case 10'turn right
            if draw_msg = false then
                pl_view = pl_view + 1
            endif
        case 11'scroll items
            itm_x = itm_x + 1
        case 20'walk left
            if draw_msg = false then
                if map(x+1,y) <> 0 then x = x + 1
            endif
        case 30, 31'scroll right
            ed_pos_x = ed_pos_x - 1
        end select
    endif
