'###_CREDITES_##################################################################
'Witchcraft
'2011 by N3trunn3r
'http://catbone.freebasic.net/
'written for FreeBASIC version 0.21.1

'###_LIBS_######################################################################
'gfx, sfx, input
#include once "n3trunn3r/imgloader.bas"
#include once "n3trunn3r/sndloader.bas"
#include once "n3trunn3r/rect.bas"
#include once "n3trunn3r/scale.bas"

'game
#include once "values.bas"
#include once "functions/subs.bas"
#include once "functions/data.bas"
#include once "functions/loading.bas"
#include once "functions/keys.bas"
#include once "functions/math.bas"
#include once "functions/draw.bas"

'###_INIT_######################################################################
data_CFG_read()'loading configuration
windowtitle "Witchcraft Adventure " + version
initscreen()
initsnd()
randomize timer

'###_MAIN_LOOP_#################################################################

do
    
    'math
    select case as const engine
    case 1 :loading()
    case 2 :keys():math_menu():cheats()
    case 10:keys():math_map3d():cheats()
    case 11:keys():math_bag()
    case 20:keys():math_map2d():cheats()
    case 30:keys():math_editor_loadmap()
    case 31:keys():math_editor()
    case 40:keys():math_object_editor()
    case 41:keys()
    case 42:keys()
    end select
    
    'images
    screenlock
    cls
    select case as const engine
    case 2 :draw_menu()
    case 10:draw_map3d()
    case 11:draw_bag()
    case 20:draw_map2d()
    case 30:draw_editor_loadmap()
    case 31:draw_editor()
    case 40:draw_object_editor()
    case 41:draw_tile_chooser()
    case 42:draw_image_chooser()
    end select
    if sc_scale then scale_screen()
    if debug then draw_debug()
    screenunlock
    
    pause_cpu()
    
loop until engine = 0

'###_EXITING_###################################################################
rem imagedestroy
endsnd()
feedback_url()
end
