'###_CREDITES_##################################################################
'SpeedGUI Example
'2011 by N3trunn3r
'http://catbone.freebasic.net/
'written for FreeBASIC version 0.21.1

'###_LIBS_######################################################################
'gfx, sfx, input
#include once "n3trunn3r/speedgui.bas"
#include once "n3trunn3r/screen_init.bas"

'###_APP_#######################################################################
'check box
sgui_ch(1) = 0'selected check box, yes/no
sgui_ch(2) = 1

'radio button
sgui_ra_grp(1) = 5'current selected radio button of a radio group (id)
sgui_ra_grp(2) = 6

'combo box
sgui_co_itm(1) = 4'max items in a combo box
sgui_co_itm(2) = 2

sgui_co_itm_sel(1) = 2'current used item
sgui_co_itm_sel(2) = 1

sgui_co_grp(1,1) = "Blade Runner"'content
sgui_co_grp(1,2) = "12 Monkeys"
sgui_co_grp(1,3) = "1984"
sgui_co_grp(1,4) = "Johnny Mnemonic"

sgui_co_grp(2,1) = "James Bond"
sgui_co_grp(2,2) = "Chuck Norris"

'spin button
dim shared as short     test = 33, test2 = 2012

'info
dim shared as string    event

'-------------------------------------------------------------------------------
'set events
sub sgui_action(sgui_id as short)
    
    select case as const sgui_id
    case 1:event = "checkbox 1 is " & sgui_ch(1)
    case 2:event = "checkbox 2 is " & sgui_ch(2)
    case 3:event = "radio button group 1, event is " & sgui_ra_grp(1)
    case 4:event = "radio button group 1, event is " & sgui_ra_grp(1)
    case 5:event = "radio button group 1, event is " & sgui_ra_grp(1)
    case 6:event = "radio button group 2, event is " & sgui_ra_grp(2)
    case 7:event = "radio button group 2, event is " & sgui_ra_grp(2)
    case 8:event = "button -ok- pressed"
    case 9:event = "button -go on!- pressed"
    case 10:event = "combobox 1, selected item is " & sgui_co_itm_sel(1)
    case 11:event = "combobox 2, selected item is " & sgui_co_itm_sel(2)
    end select
    
end sub

'###_INIT_######################################################################
windowtitle "SpeedGUI Example"
screen_init
sgui_init

'###_MAIN_LOOP_#################################################################
do
    
    screenlock:cls
    mouse
    sgui_bg(0,0,640,480)
    
    '          x  y     ID   grp
    sgui_check(10,10,   1,"1")
    sgui_check(10,30,   2,"2")
    
    sgui_radio(50,10,   3   ,1,"1")
    sgui_radio(50,30,   4   ,1,"2")
    sgui_radio(50,50,   5   ,1,"3")
    
    'sgui_radio(70,10,   6   ,2)
    'sgui_radio(70,30,   7   ,2)
    
    sgui_button(100,10, 8   ,60,"OK")
    sgui_button(100,40, 9   ,80,"Go on!")
    
    sgui_combo(200,40,  10  ,1,120)
    sgui_combo(200,10,  11  ,2,100)
    
    sgui_spin (350,10,  test2,80)
    sgui_spin (350,40,  test,50)
    
    color rgb(255,255,255)
    locate 29,3
    print "Last event: " & event
    
    screenunlock:sleep 20,1
    
loop until multikey(fb.sc_escape)
