'###_CREDITS_###################################################################
'screen_init 1.2
'2008-2011 by N3trunn3r
'n3trunn3r@catbone.freebasic.net
'http://catbone.freebasic.net/
'written for FreeBASIC version 0.21.1

'###_LIBRARIES_#################################################################
#include once "fbgfx.bi"
#include once "n3trunn3r/error.bas"
#include once "n3trunn3r/file.bas"

'###_SHARED_VALUES_#############################################################
dim shared  as integer  file_CFG:file_CFG=freefile
dim shared  as string   path_CFG:path_CFG="config.ini"
dim shared  as short    sc_x, sc_y
dim shared  as byte     sc_col, sc_full
const       as short    sc_x_def=640, sc_y_def=480
const       as byte     sc_col_def=32, sc_full_def=0

'###_FUNCTIONES_################################################################
declare sub initscreen()
declare sub data_CFG_read()
declare sub data_CFG_write(write_def as byte=0)

'-------------------------------------------------------------------------------
sub initscreen()
    
    data_CFG_read()
    
    dim as integer fullscreen
    if sc_full=0 then
        fullscreen=&h00
    elseif sc_full=1 then
        fullscreen=&h01
    endif
    
    screenres sc_x,sc_y,sc_col,1,fullscreen
    
end sub

'-------------------------------------------------------------------------------
sub data_CFG_read()
    
    file = freefile'file_CFG
    path = path_CFG
    
    if open(path for input as #file) <> 0 then
        data_CFG_write(1)'write defaults
    endif
    
    
    file = freefile
    open path for input as #file
        input #file, _
        sc_x, sc_y, sc_col, sc_full
    close
    
end sub

'-------------------------------------------------------------------------------
sub data_CFG_write(write_def as byte=0)
    
    file = file_CFG
    path = path_CFG
    
    if open(path for output as #file) <> 0 then
        er("data_CFG_write: file write error " & path)
    endif
    
    kill path
    
    open path for output as #file
        if write_def=0 then
            write #file, _
            sc_x, sc_y, sc_col, sc_full
        elseif write_def=1 then
            write #file, _
            sc_x_def, sc_y_def, sc_col_def, sc_full_def
        endif
    close
    
end sub
