#version 130
#extension GL_EXT_gpu_shader4 : enable
uniform sampler2DArray texture;
in vec4 texCoord;
in vec4 colordata;

void main(void) {

	vec4 color = texture2DArray(texture, texCoord.xyz);
	if (color[3] == 0.0) discard; // le discard!
	
	float alpha = min(0.98, smoothstep(0.0, 1.0, pow(colordata[3], 0.9) ) );
	color = vec4( mix(color.rgb, colordata.rgb, alpha), color[3] );
	
	gl_FragColor = color;

}
