declare sub draw_debug()
declare sub draw_menu()
'declare sub draw_map3d() see math.bas header
'declare sub draw_map2d()
declare sub draw_bag()
declare sub draw_editor_loadmap()
declare sub draw_editor()
declare sub draw_object_editor()
declare sub draw_tile_chooser()
declare sub draw_image_chooser()

'-------------------------------------------------------------------------------
sub draw_debug()
    
    inc():locate 1,1
    dim as string driver
    ScreenInfo ,,,,,,driver
    print driver
    print "pl_hu_drain ";pl_hu_drain
    print "pl_hu ";pl_hu
    'print "volume_music ";volume_music
    'print "volume_sound ";volume_sound
    'print "key_down";key_down
    'print "world_x ";world_x
    'print "world_y ";world_y
    'print "x     ";x
    'print "x_old ";x_old
    'print "y     ";y
    'print "y_old ";y_old
    'print "data_post(map(x,y)) ";data_post(map(x,y))
    'print "map(x,y) ";map(x,y)
    'print "key_hit ";key_hit
    'print "pl_hp ";pl_hp
    'print "next fight_round ";fight_round
    'print "fight_anim ";fight_anim
    'print "auto_play ";auto_play
    'print "speed ";speed
    'print "engine ";engine
    'print "draw_msg ";draw_msg
    'print "data_type(obed_id) ";data_type(obed_id)
    'print "data_image_type(obed_id) ";data_image_type(obed_id)
    'print "mouse_button ";mouse_button
    'print "choice ";choice
    'print "draw_msg ";draw_msg
    'print "mouse_x ";mouse_x
    'print "mouse_y ";mouse_y
    'print "ed_x ";ed_x
    'print "ed_y ";ed_y
    'print "draw_msg ";draw_msg
    'print "data_type(map(x,y)) ";data_type(map(x,y))
    'print "mouse_ed_pos_x ";mouse_ed_pos_x
    'print "mouse_ed_pos_y ";mouse_ed_pos_y
    'print "ed_pos_x ";ed_pos_x
    'print "ed_pos_y ";ed_pos_y
    'print "pl_xp ";pl_xp
    'print "pl_hp ";pl_hp
    'print "pl_hp_max ";pl_hp_max
    
end sub

'-------------------------------------------------------------------------------
sub draw_menu()
    
    'bg
    drawimg(img_menu_bg(1))
    
    'version
    print2(str(version),0,sc_y_game_def-10)
    
    'menu
    select case as const i_menu
    case 0:drawimg(img_menu_1(1),0,0,3)'main
    case 1:drawimg(img_menu_2(1),0,0,3)'game
    case 2:drawimg(img_menu_3(1),0,0,3)'options
    end select
    
    'resolution info
    if i_menu = 2 and i_menu_cur_pos = 2 then
        select case as const sc_filter
        case 1:print2 "320 x 240 - 1x Normal"
        case 2:print2 "640 x 480 - 2x Nearest Neighbour (by D.J.Peters)"
        case 3:print2 "640 x 480 - 2x Eagle (by 1000101)"
        case 4:print2 "640 x 480 - 2x Eagle (by rolliebollocks)"
        end select
    endif
    
    'menu cursor
    select case as const i_menu_cur_pos
    case 0:drawimg(img_menu_cursor(1),97,129,3)
    case 1:drawimg(img_menu_cursor(1),97,153,3)
    case 2:drawimg(img_menu_cursor(1),97,177,3)
    case 3:drawimg(img_menu_cursor(1),97,201,3)
    end select
    
end sub

'-------------------------------------------------------------------------------
sub draw_map3d()
    
    dim as ushort pos_3d(15)
    
    select case as const pl_view
        case 1'north
            pos_3d(1) = map(x-1  ,y-2)
            pos_3d(2) = map(x+1  ,y-2)
            pos_3d(3) = map(x-1  ,y-1)
            pos_3d(4) = map(x+1  ,y-1)
            pos_3d(5) = map(x-1  ,y)
            pos_3d(6) = map(x+1  ,y)
            pos_3d(7) = map(x    ,y-2)
            pos_3d(8) = map(x    ,y-1)
            pos_3d(9) = map(x    ,y)
        case 2'east
            pos_3d(1) = map(x+2  ,y-1)
            pos_3d(2) = map(x+2  ,y+1)
            pos_3d(3) = map(x+1  ,y-1)
            pos_3d(4) = map(x+1  ,y+1)
            pos_3d(5) = map(x    ,y-1)
            pos_3d(6) = map(x    ,y+1)
            pos_3d(7) = map(x+2  ,y)
            pos_3d(8) = map(x+1  ,y)
            pos_3d(9) = map(x    ,y)
        case 3'south
            pos_3d(1) = map(x+1  ,y+2)
            pos_3d(2) = map(x-1  ,y+2)
            pos_3d(3) = map(x+1  ,y+1)
            pos_3d(4) = map(x-1  ,y+1)
            pos_3d(5) = map(x+1  ,y)
            pos_3d(6) = map(x-1  ,y)
            pos_3d(7) = map(x    ,y+2)
            pos_3d(8) = map(x    ,y+1)
            pos_3d(9) = map(x    ,y)
        case 4'west
            pos_3d(1) = map(x-2  ,y+1)
            pos_3d(2) = map(x-2  ,y-1)
            pos_3d(3) = map(x-1  ,y+1)
            pos_3d(4) = map(x-1  ,y-1)
            pos_3d(5) = map(x    ,y+1)
            pos_3d(6) = map(x    ,y-1)
            pos_3d(7) = map(x-2  ,y)
            pos_3d(8) = map(x-1  ,y)
            pos_3d(9) = map(x    ,y)
    end select
    
    dim as ubyte fn
    
    'floor and walls
    for fn = 1 to 9
        select case as const data_type(pos_3d(fn))
        case 101 to 100+i_ts3dr_x
            'floor
            if rnd_floor = false then
                drawimg(img_tiles_3d(fn+((data_type(pos_3d(fn))-100)*i_ts3dr_x)-i_ts3dr_x))
            elseif rnd_floor = true then
                select case as const fn
                case 7,8,9:drawimg(img_tiles_3d( fn   +((data_type(pos_3d(fn))-100)*i_ts3dr_x)-i_ts3dr_x),,,11)
                case 1,3,5:drawimg(img_tiles_3d((fn+1)+((data_type(pos_3d(fn))-100)*i_ts3dr_x)-i_ts3dr_x),,,11)'jumps one tile forwared
                case 2,4,6:drawimg(img_tiles_3d((fn-1)+((data_type(pos_3d(fn))-100)*i_ts3dr_x)-i_ts3dr_x),,,11)'jumps one tile backward
                end select
            endif
            'walls
            if data_block(pos_3d(fn)) = 1 then
                if fn < 5 then'fields in view 1-4
                    drawimg(img_tiles_3d(fn+9+((data_type(pos_3d(fn))-100)*i_ts3dr_x)-i_ts3dr_x))
                endif
                'fields in view
                drawimg(img_tiles_3d(fn+13+((data_type(pos_3d(fn))-100)*i_ts3dr_x)-i_ts3dr_x))
            endif
        'floor - draw default map_type on all other objects
        case 0 to 100
            if rnd_floor = false then
                drawimg(img_tiles_3d(fn+(map_type*i_ts3dr_x)-i_ts3dr_x))
            elseif rnd_floor = true then
                select case as const fn
                case 7,8,9:drawimg(img_tiles_3d( fn   +(map_type*i_ts3dr_x)-i_ts3dr_x),,,11)
                case 1,3,5:drawimg(img_tiles_3d((fn+1)+(map_type*i_ts3dr_x)-i_ts3dr_x),,,11)'jumps one tile forwared
                case 2,4,6:drawimg(img_tiles_3d((fn-1)+(map_type*i_ts3dr_x)-i_ts3dr_x),,,11)'jumps one tile backward
                end select
            endif
        end select
    next
    
    'floor objects
    if data_block(pos_3d(8)) = 0 then'bug prevention - see items though walls
        if data_image_type(pos_3d(7)) = 0 and data_type(pos_3d(7)) < 100 then'pos 7
            if data_spirit(pos_3d(7)) <> 3 then drawimg(img_tiles_1x0c5x(data_image(pos_3d(7))),(i_dis_x-i_tss)/2,104)
        endif
    endif
        if data_image_type(pos_3d(8)) = 0 and data_type(pos_3d(8)) < 100 then'pos 8
            if data_spirit(pos_3d(8)) <> 3 then drawimg(img_tiles_2x1x(data_image(pos_3d(8))),(i_dis_x-i_tss*2)/2,136)
        endif
        if data_image_type(pos_3d(9)) = 0 and data_type(pos_3d(9)) < 100 then'pos 9
            if data_spirit(pos_3d(9)) <> 3 then drawimg(img_tiles_5x2x(data_image(pos_3d(9))),(i_dis_x-i_tss*4)/2,176)
        endif
    
    'room objects
    if data_block(pos_3d(8)) = 0 then'bug prevention - see items though walls
        if data_image_type(pos_3d(7)) = 1 and data_type(pos_3d(7)) < 100 then'pos 7
            if data_spirit(pos_3d(7)) <> 3 then drawimg(img_tiles(data_image(pos_3d(7))),(i_dis_x-i_tss)/2,85)
        endif
    endif
        if data_image_type(pos_3d(8)) = 1 and data_type(pos_3d(8)) < 100 then'pos 8
            if data_spirit(pos_3d(8)) <> 3 then drawimg(img_tiles_2x(data_image(pos_3d(8))),(i_dis_x-i_tss*2)/2,87)
        endif
        if data_image_type(pos_3d(9)) = 1 and data_type(pos_3d(9)) < 100 then'pos 9
            'movement animation
            if data_type(pos_3d(9)) = 9 then
                select case as const ani_en_move
                case 0 to 50
                    drawimg(img_tiles_5x(data_image(pos_3d(9))),(i_dis_x-i_tss*5)/2,60)
                    'enemy got hit
                    if fight_anim = 1 then
                        drawimg(img_tiles_5x(data_image(pos_3d(9))),(i_dis_x-i_tss*5)/2,60,4,128)
                    endif
                case 51 to 100
                    drawimg(img_tiles_5x(data_image(pos_3d(9))),(i_dis_x-i_tss*5)/2+5,60)
                    'enemy got hit
                    if fight_anim = 1 then
                        drawimg(img_tiles_5x(data_image(pos_3d(9))),(i_dis_x-i_tss*5)/2+5,60,4,128)
                    endif
                end select
                if ani_en_move = 100 then ani_en_move = 0
                ani_en_move = ani_en_move + 1
            'normal item / no animation
            else
                if data_spirit(pos_3d(9)) <> 3 then drawimg(img_tiles_5x(data_image(pos_3d(9))),(i_dis_x-i_tss*5)/2,60)
            endif
        endif
    
    'fight
    select case as const fight_anim
    case 1'player hits enemy
        drawimg(img_hit(1),((sc_x_game_def - 30 - (rnd*60)) / 2), ((sc_y_game_def - 30 - (rnd*60)) / 2),3)
    case 2'player misses enemy
        'drawimg(img_slice(1),((sc_x_game_def - 37) / 2), ((sc_y_game_def - 33) / 2))
    case 3'enemy hits player
        drawimg(img_hit(1),((rnd * sc_x_game_def-90)), (sc_y_game_def - 40 - (rnd*20)),3)
    case 4'enemy misses player
        'drawimg(img_slice(1),((sc_x_game_def - 37) / 2), ((sc_y_game_def + 203) / 2))
    end select
    
    'enemy hp bar
    if data_type(map(x,y)) = 9 then
        drawimg(img_enemy_hp_bar(1),0,0,3)
        color rgb(235,0,0)
        rect(135,37,en_hp(x,y) * 50 / data_value_1(map(x,y)),6)
    endif
    
    'shortener
    dim as short gui_up_y_a=3 , gui_down_y_a=219
    dim as short gui_up_y_b=15, gui_down_y_b=230
    
    'gui
    drawimg(img_gui(1),0,0,3)
    
    'experience
    color rgb(196,196,196)
    rect(16,4,pl_xp * 20 / pl_xp_max,6)
    'gold
    print2(str(pl_money),14,gui_up_y_b)
    
    'strength
    print2(str(pl_str),106,gui_up_y_a)
    'defense
    print2(str(pl_def),106,gui_up_y_b)
    
    'dexterity
    print2(str(pl_dex),59,gui_up_y_a)
    'level
    print2(str(pl_level),59,gui_up_y_b)
    
    'fire_resistance
    'print2(str(pl_fire)+" %",164,152)
    'ice_resistance
    'print2(str(pl_ice)+" %",164,175)
    
    'map position
    print2(str(x),272,gui_up_y_a)
    print2(str(y),272,gui_up_y_b)
    
    'mini map
    if draw_mini_map = true and mini_map(world_x,world_y) = 1 then
        dim as short fn_x, fn_y
        for fn_x = 1 to x_max
            for fn_y = 1 to y_max
                'draw map
                'floor
                if data_block(map(fn_x,fn_y)) = 1 then
                    color rgb(102,102,102)
                    pset( fn_x - x + (sc_x_game_def / 2), fn_y - y + (sc_y_game_def / 2) )
                'walls
                elseif data_block(map(fn_x,fn_y)) = 2 then
                    color rgb(178,178,178)
                    pset( fn_x - x + (sc_x_game_def / 2), fn_y - y + (sc_y_game_def / 2) )
                'everything else
                elseif map(fn_x,fn_y) > 0 then
                    color rgb(178,178,178)
                    pset( fn_x - x + (sc_x_game_def / 2), fn_y - y + (sc_y_game_def / 2) )
                endif
                'player
                if fn_x = x and fn_y = y then
                    color rgb(196,0,0)
                    pset( fn_x - x + (sc_x_game_def / 2), fn_y - y + (sc_y_game_def / 2) )
                endif
            next
        next
    endif
    
    'mini map icon
    if mini_map(world_x,world_y) = 1 then
        drawimg(img_mini_map(1),160-3,gui_down_y_a-4)
    endif
    
    'compass
    if draw_compass = 1 then
        drawimg(img_compass(pl_view),160-9,gui_down_y_a)
    endif
    
    'health
    color rgb(235,0,0)
    rect(4,gui_down_y_a,pl_hp * 50 / pl_hp_max,6)
    'mana
    color rgb(0,0,237)
    rect(4,gui_down_y_b,pl_ma * 50 / pl_ma_max,6)
    
    'thirst
    color rgb(0,158,158)
    rect(266,gui_down_y_a,pl_th * 50 / pl_th_max,6)
    'hunger
    color rgb(0,204,0)
    rect(266,gui_down_y_b,pl_hu * 50 / pl_hu_max,6)
    
    'message
    if draw_msg >= 1 then
        drawimg(img_text_frame(1),0,sc_y_game_def-65)
        'message
        if data_type(map(x,y)) = 7 then
            print2(str(data_strings(data_value_1(map(x,y)))),2,sc_y_game_def-62)
            print2(str(data_strings(data_value_2(map(x,y)))),2,sc_y_game_def-52)
            print2(str(data_strings(data_value_3(map(x,y)))),2,sc_y_game_def-42)
            print2(str(data_strings(data_value_4(map(x,y)))),2,sc_y_game_def-32)
            print2(str(data_strings(data_value_5(map(x,y)))),2,sc_y_game_def-22)
            print2(str(data_strings(data_value_6(map(x,y)))),2,sc_y_game_def-12)
        'choice
        elseif data_type(map(x,y)) = 8 then
            if choice = 1 then
                drawimg(img_choice(1),2,sc_y_game_def-32,3)
            elseif choice = 2 then
                drawimg(img_choice(1),2,sc_y_game_def-22,3)
            endif
            print2(str(data_strings(data_value_1(map(x,y)))),2,sc_y_game_def-62)
            print2(str(data_strings(data_value_2(map(x,y)))),2,sc_y_game_def-52)
            print2(str(data_strings(data_value_3(map(x,y)))),2,sc_y_game_def-32)
            print2(str(data_strings(data_value_4(map(x,y)))),2,sc_y_game_def-22)
        endif
    endif
    
end sub

'-------------------------------------------------------------------------------
sub draw_map2d()
    
    dim as ubyte fn_x, fn_y
    dim as short next_pos_x, next_pos_y
    dim as ushort map_pos
    
    'bg color
    inc()
    
    'draw map
    for fn_x = 1 to x_max
        for fn_y = 1 to y_max
            'shortener
            next_pos_x = (-x * i_tss) + (i_tss * (fn_x+4) +16 )
            next_pos_y = (-y * i_tss) + (i_tss * (fn_y+3) +8 )
            'shortener
            map_pos = map(fn_x,fn_y)
            'default bg
            if map(fn_x,fn_y) <> 0 then
                drawimg(img_tiles(data_image(map_type)),next_pos_x,next_pos_y)
            endif
            'tiles with images
            if data_image(map_pos) > 0 then
                drawimg(img_tiles(data_image(map_pos)),next_pos_x,next_pos_y)
            endif
            'mark unwalkable tiles
            if data_block(map_pos) = 1 then
                drawimg(img_block(1),next_pos_x,next_pos_y,2,96)
            endif
        next
    next
    
    'player
    drawimg(img_tiles(1),(i_tss * 4)+16,(i_tss * 3)+8)
    
    'gui
    drawimg(img_gui_death(1),0,0,3)
    
    'shortener
    dim as short gui_up_y_a=3 , gui_down_y_a=219
    dim as short gui_up_y_b=15, gui_down_y_b=230
    
    'mana
    color rgb(0,0,237)
    rect(4,gui_down_y_b,pl_ma * 50 / pl_ma_max,6)
    
    'map position
    print2(str(x),272,gui_up_y_a)
    print2(str(y),272,gui_up_y_b)
    
    'message
    if draw_msg >= 1 then
        drawimg(img_text_frame(1),0,sc_y_game_def-65)
        'message
        if data_type(map(x,y)) = 7 then
            print2(str(data_strings(data_value_1(map(x,y)))),2,sc_y_game_def-62)
            print2(str(data_strings(data_value_2(map(x,y)))),2,sc_y_game_def-52)
            print2(str(data_strings(data_value_3(map(x,y)))),2,sc_y_game_def-42)
            print2(str(data_strings(data_value_4(map(x,y)))),2,sc_y_game_def-32)
            print2(str(data_strings(data_value_5(map(x,y)))),2,sc_y_game_def-22)
            print2(str(data_strings(data_value_6(map(x,y)))),2,sc_y_game_def-12)
        'choice
        elseif data_type(map(x,y)) = 8 then
            if choice = 1 then
                drawimg(img_choice(1),2,sc_y_game_def-32,3)
            elseif choice = 2 then
                drawimg(img_choice(1),2,sc_y_game_def-22,3)
            endif
            print2(str(data_strings(data_value_1(map(x,y)))),2,sc_y_game_def-62)
            print2(str(data_strings(data_value_2(map(x,y)))),2,sc_y_game_def-52)
            print2(str(data_strings(data_value_3(map(x,y)))),2,sc_y_game_def-32)
            print2(str(data_strings(data_value_4(map(x,y)))),2,sc_y_game_def-22)
        endif
    endif
    
end sub

'-------------------------------------------------------------------------------
sub draw_bag()
    
    'bagpack
    drawimg(img_bagpack(1))
    
    'items
    dim as ubyte fn_x, fn_y
    for fn_x = 1 to itm_x_max
        for fn_y = 1 to itm_y_max
            drawimg(img_tiles(data_image(itm(fn_x,fn_y))), _
            itm_st + ((fn_x - 1) * (itm_sq + itm_sp)) , _
            itm_st + ((fn_y - 1) * (itm_sq + itm_sp)) , _
            )
        next
    next
    
    'item info
    if itm(itm_x,itm_y) > 0 then
        print2(str(data_names(itm(itm_x,itm_y))),2,sc_y_game_def-55)
        select case as const data_value_1(itm(itm_x,itm_y))
        case 0'common item
            
        case 1'weapon
            print2("Str+ "+str(data_value_2(itm(itm_x,itm_y))),2,sc_y_game_def-35)
        case 2 to 7'armors
            print2("Def+ "+str(data_value_2(itm(itm_x,itm_y))),2,sc_y_game_def-35)
        case 8'amulet
            
        case 9'ring
            
        end select
    endif
    
    'shortener
    dim as short itm_pos_x = (itm_st + (itm_x * (itm_sp + itm_sq))) - (itm_sp + itm_sq)
    dim as short itm_pos_y = (itm_st + (itm_y * (itm_sp + itm_sq))) - (itm_sp + itm_sq)
    
    'cursor
    drawimg(img_bcur(1),itm_pos_x,itm_pos_y,3)
    
    'cursor item picket up
    if itm_sel > 0 then
        drawimg(img_tiles(data_image(itm_sel)),itm_pos_x+(i_tss/4),itm_pos_y+(i_tss/4),2,128)
    endif
    
end sub

'-------------------------------------------------------------------------------
sub draw_editor_loadmap()
    
    dim as ubyte fn_x, fn_y
    dim as short ed_draw_x, ed_draw_y
    
    'bg
    drawimg(img_obed_bg_2x(1))
    
    'bg color
    color rgb(128,128,128)
    rect(ed_pos_x * i_tss, ed_pos_y * i_tss, i_tss * i_mws, i_tss * i_mws)
    
    'image world map
    drawimg(img_world_map(1), ed_pos_x * i_tss, ed_pos_y * i_tss)
    
    'draw worldmap
    for fn_x = 1 to i_mws
        for fn_y = 1 to i_mws
            'shortener
            ed_draw_x = ed_pos_x * i_tss + (i_tss * fn_x - i_tss)
            ed_draw_y = ed_pos_y * i_tss + (i_tss * fn_y - i_tss)
            'mark levels
            color rgb(0,0,0)
            rect(ed_draw_x,ed_draw_y,i_tss,i_tss,0)
            print2(str(fn_x)+str(fn_y),ed_draw_x+15,ed_draw_y+11,1,7)
        next
    next
    
    'draw mouse
    if not mouse_x = -1 then'bug preventing - if mouse is out of the window
        'draw frame
        color rgb(255,0,0)
        rect(mouse_ed_pos_x,mouse_ed_pos_y,i_tss,i_tss,0)
        'draw mouse
        drawimg(img_mouse(1),mouse_x,mouse_y,3)
    endif
    
end sub

'-------------------------------------------------------------------------------
sub draw_editor()
    
    dim as ubyte fn_x, fn_y
    dim as short ed_draw_x, ed_draw_y
    dim as ushort map_pos
    
    'draw map
    for fn_x = 1 to x_max
        for fn_y = 1 to y_max
            
            'shortener
            ed_draw_x = ed_pos_x * i_tss + (i_tss * fn_x - i_tss)
            ed_draw_y = ed_pos_y * i_tss + (i_tss * fn_y - i_tss)
            'shortener
            map_pos = map(fn_x,fn_y)
            
            'mark empty tiles
            if map_pos = 0 then
                color rgb(128,128,128)
                rect(ed_draw_x,ed_draw_y,i_tss,i_tss)
                color rgb(0,196,0)
                rect(ed_draw_x,ed_draw_y,i_tss,i_tss,0)
            'mark unknown tiles
            elseif map_pos + data_image(map_pos) = 0 then
                color rgb(128,128,128)
                rect(ed_draw_x,ed_draw_y,i_tss,i_tss)
                color rgb(0,196,0)
                rect(ed_draw_x,ed_draw_y,i_tss,i_tss,0)
                print2("?",ed_draw_x+(i_tss/2),ed_draw_y+(i_tss/2)-4,1,9)
            'mark tiles without image (events)
            elseif data_image(map_pos) = 0 then
                drawimg(img_tiles(data_image(map_type)),ed_draw_x,ed_draw_y)
                print2("!",ed_draw_x+(i_tss/2),ed_draw_y+(i_tss/2)-4,1,9)
            'mark other map types with default bg image for everything
            else
                drawimg(img_tiles(data_image(map_type)),ed_draw_x,ed_draw_y)
            endif
            
            'tiles with images
            if data_image(map_pos) > 0 then
                drawimg(img_tiles(data_image(map_pos)),ed_draw_x,ed_draw_y)
            endif
            
            'mark unwalkable tiles
            if data_block(map_pos) = 1 then
                drawimg(img_block(1),ed_draw_x,ed_draw_y,2,96)
            elseif data_block(map_pos) = 2 then
                drawimg(img_block(2),ed_draw_x,ed_draw_y)
            endif
            
            'mark auto activation
            if data_active(map_pos) = 1 then
                drawimg(img_block(3),ed_draw_x,ed_draw_y)
            endif
            
            'mark post event
            if data_post(map_pos) = map_type then
                drawimg(img_block(6),ed_draw_x,ed_draw_y)
            elseif data_post(map_pos) > 0 then
                drawimg(img_block(4),ed_draw_x,ed_draw_y)
            endif
            
            'mark portals
            if data_type(map_pos) = 4 then
                drawimg(img_block(5),ed_draw_x,ed_draw_y)
            endif
            
        next
    next
    
    'mark portal exits
    if data_type(ed_sel_tile) = 4 then
        drawimg(img_block(5), _
        ((ed_pos_x + data_value_1(ed_sel_tile) - 1) * i_tss), _
        ((ed_pos_y + data_value_2(ed_sel_tile) - 1) * i_tss) _
        )
        'mark if next level
        if data_value_3(ed_sel_tile) > 0 and data_value_4(ed_sel_tile) > 0 then
            drawimg(img_block(5), _
            ((ed_pos_x + data_value_1(ed_sel_tile) - 1) * i_tss)+10, _
            ((ed_pos_y + data_value_2(ed_sel_tile) - 1) * i_tss) _
            )
        endif
    endif
    
    'mark replace exits
    if data_type(ed_sel_tile) = 1 then
        drawimg(img_block(7), _
        ((ed_pos_x + data_value_2(ed_sel_tile) - 1) * i_tss), _
        ((ed_pos_y + data_value_3(ed_sel_tile) - 1) * i_tss) _
        ,2,128)
    endif
    
    'draw info
    drawimg(img_text_frame_editor(1),0,600-24)
    if mouse_y < 600-24 then'bug preventing - mouse out of range
        print2("Pos X: "+str(ed_x),10,583)
        print2("Pos Y: "+str(ed_y),100,583)
        print2("Tile ID: "+str(map(ed_x,ed_y)),200,583)
        print2("Tile Name: "+str(data_names(map(ed_x,ed_y))),300,583)
        print2("Selected ID: "+str(ed_sel_tile),475,583)
        drawimg(img_tiles(data_image(ed_sel_tile)),sc_x_edit_def-i_tss,sc_y_edit_def-i_tss)
        print2("Selected Name: "+str(data_names(ed_sel_tile)),600,583)
    endif
    
    'draw mouse
    if not mouse_x = -1 then'bug preventing - if mouse is out of the window
        'draw frame
        color rgb(255,0,0)
        rect(mouse_ed_pos_x,mouse_ed_pos_y,i_tss,i_tss,0)
        'draw mouse
        drawimg(img_mouse(1),mouse_x,mouse_y,3)
    endif
    
end sub

'-------------------------------------------------------------------------------
sub draw_object_editor()
    
    dim as short px_a=20,           px_b=110,       px_c=70
    dim as short x_sp=260, txt_sp=130, py_a=10
    dim as short px_d=px_a+x_sp,    px_e=px_b+x_sp, px_f=px_c+x_sp
    dim as string text_type
    
    'bg
    drawimg(img_obed_bg_2x(1))
    
    
    
    'name
    print2("#"+str(data_id(ed_sel_tile))+" "+str(data_names(ed_sel_tile)),sc_x_edit_def/2-1,5,1)
    
    'picture and id
    color rgb(0,0,0)
    rect sc_x_edit_def/2-32,20,64,64,0
    if data_image(ed_sel_tile) = 0 then
        print2("No Image",sc_x_edit_def/2-1,47,1)
    elseif data_image_type(ed_sel_tile) = 0 then
        drawimg(img_tiles_2x1x(data_image(ed_sel_tile)),(sc_x_edit_def-64)/2,52)
    elseif data_image_type(ed_sel_tile) = 1 then
        drawimg(img_tiles_2x(data_image(ed_sel_tile)),(sc_x_edit_def-64)/2,20)
    endif
    obed_btn(                       sc_x_edit_def/2-60,    30,     1,  1,decrease)
    obed_btn(                       sc_x_edit_def/2+60-11, 30,     3,  1,increase)
    
    'image id
    obed_btn(                       sc_x_edit_def/2-60,    50,     1,  4,decrease)
    obed_btn(                       sc_x_edit_def/2+60-11, 50,     3,  4,increase)
    
    'image type id
    obed_btn(                       sc_x_edit_def/2-60,    70,     1,  5,decrease)
    obed_btn(                       sc_x_edit_def/2+60-11, 70,     3,  5,increase)
    
    
    
    'type
    obed_btn(                       px_a,   py_a*12,    1,  2,decrease)
    obed_btn(                       px_b,   py_a*12,    3,  2,increase,"Type")
    select case as const data_type(ed_sel_tile)
    case 100:text_type="Player"
    case 101 to 100+i_ts3dr_y:text_type="Tile "+str(data_type(ed_sel_tile))
    case 0:text_type="Decor"
    case 1:text_type="Replace"
    case 2:text_type="Status"
    case 3:text_type="Status"
    case 4:text_type="Teleport"
    case 5:text_type="Item"
    case 6:text_type="Del Item"
    case 7:text_type="Message"
    case 8:text_type="Choice"
    case 9:text_type="Fight"
    case 10:text_type="Recepy"
    case 11:text_type="Mini Map"
    case 12:text_type="Compass"
    end select
    print2(text_type,               px_c,   py_a*12,    1)
    
    'after event
    obed_btn(                       px_a,   py_a*14,    1,  7,decrease)
    obed_btn(                       px_b,   py_a*14,    3,  7,increase,"After Event")
    print2(str(data_post(ed_sel_tile)), px_c,   py_a*14,    1)
    
    'block
    obed_btn(                       px_a,   py_a*16,    1,  8,decrease)
    obed_btn(                       px_b,   py_a*16,    3,  8,increase,"Block Type")
    select case as const data_block(ed_sel_tile)
    case 0:text_type="Free"
    case 1:text_type="Wall"
    case 2:text_type="Stop"
    end select
    print2(text_type,               px_c,   py_a*16,    1)

    'wait
    obed_btn(                       px_a,   py_a*18,    1,  15,decrease)
    obed_btn(                       px_b,   py_a*18,    3,  15,increase,"Wait 10.sec")
    print2(str(data_wait(ed_sel_tile)), px_c,   py_a*18,    1)
    
    'sound
    obed_btn(                       px_a,   py_a*20,    1,  16,decrease)
    obed_btn(                       px_b,   py_a*20,    3,  16,increase,"Sound")
    obed_btn(                       px_b+60,py_a*20,    8,  26)
    print2(str(data_sfx(ed_sel_tile)),  px_c,   py_a*20,    1)
    
    'spirit use
    obed_btn(                       px_a,   py_a*22,    1,  17,decrease)
    obed_btn(                       px_b,   py_a*22,    3,  17,increase,"Spirit Use")
    select case as const data_spirit(ed_sel_tile)
    case 0:text_type="Human"
    case 1:text_type="Both"
    case 2:text_type="Spirit"
    case 3:text_type="Invisible"
    end select
    print2(text_type,               px_c,   py_a*22,    1)
    
    'auto activate
    obed_btn(                       px_a,   py_a*24,    5,  6,increase,"Auto Activate")
    
    
    'value 1
    obed_btn(                       px_d,   py_a*12,    1,  9,decrease)
    select case as const data_type(ed_sel_tile)
    case 100:text_type="-"
    case 101 to 100+i_ts3dr_y:text_type="-"
    case 0:text_type="-"
    case 1:text_type="Object ID"
    case 2:text_type="HP"
    case 3:text_type="Str"
    case 4:text_type="Map X"
    case 5:text_type="Item Type"
        select case as const data_value_1(ed_sel_tile)
        case 0:text_type="Common"
        case 1:text_type="Weapon"
        case 2:text_type="Shield"
        case 3:text_type="Armor"
        case 4:text_type="Head"
        case 5:text_type="Robe"
        case 6:text_type="Hands"
        case 7:text_type="Feet"
        case 8:text_type="Amulet"
        case 9:text_type="Ring"
        end select
    case 6:text_type="Item ID"
    case 7:text_type="Text #1":print2(data_strings(data_value_1(ed_sel_tile)),px_f+txt_sp, py_a*12)
    case 8:text_type="Text #1":print2(data_strings(data_value_1(ed_sel_tile)),px_f+txt_sp, py_a*12)
    case 9:text_type="HP Max"
    case 10:text_type="Item #1 ID"+"   "+str(data_names(data_value_1(ed_sel_tile)))
    case 11
        select case as const data_value_1(ed_sel_tile)
        case 0:text_type="Take Mini Map"
        case 1:text_type="Get Mini Map"
        end select
    case 12
        select case as const data_value_1(ed_sel_tile)
        case 0:text_type="Take Compass"
        case 1:text_type="Get Compass"
        end select
    end select
    obed_btn(                       px_e,   py_a*12,    3,  9,increase,text_type)
    print2(str(data_value_1(ed_sel_tile)),px_f, py_a*12,    1)
    
    'value 2
    obed_btn(                       px_d,   py_a*14,    1,  10,decrease)
    select case as const data_type(ed_sel_tile)
    case 100:text_type="-"
    case 101 to 100+i_ts3dr_y:text_type="-"
    case 0:text_type="-"
    case 1:text_type="Map X"
    case 2:text_type="HP Max"
    case 3:text_type="Def"
    case 4:text_type="Map Y"
    case 5
        select case as const data_value_1(ed_sel_tile)
        case 1:text_type="Str"
        case 2 to 7:text_type="Def"
        case 0, 8, 9:text_type="-"
        end select
    case 6:text_type="-"
    case 7:text_type="Text #2":print2(data_strings(data_value_2(ed_sel_tile)),px_f+txt_sp, py_a*14)
    case 8:text_type="Text #2":print2(data_strings(data_value_2(ed_sel_tile)),px_f+txt_sp, py_a*14)
    case 9:text_type="Str"
    case 10:text_type="Item #2 ID"+"   "+str(data_names(data_value_2(ed_sel_tile)))
    case 11:text_type="World X"
    case 12:text_type="-"
    end select
    obed_btn(                       px_e,   py_a*14,    3,  10,increase,text_type)
    print2(str(data_value_2(ed_sel_tile)),px_f, py_a*14,    1)
    
    'value 3
    obed_btn(                       px_d,   py_a*16,    1,  11,decrease)
    select case as const data_type(ed_sel_tile)
    case 100:text_type="-"
    case 101 to 100+i_ts3dr_y:text_type="-"
    case 0:text_type="-"
    case 1:text_type="Map Y"
    case 2:text_type="Mana"
    case 3:text_type="Dex"
    case 4:text_type="World X"
    case 5:text_type="Replace pos"
    case 6:text_type="-"
    case 7:text_type="Text #3":print2(data_strings(data_value_3(ed_sel_tile)),px_f+txt_sp, py_a*16)
    case 8:text_type="Choice #1":print2(data_strings(data_value_3(ed_sel_tile)),px_f+txt_sp, py_a*16)
    case 9:text_type="Def"
    case 10:text_type="-"
    case 11:text_type="World Y"
    end select
    obed_btn(                       px_e,   py_a*16,    3,  11,increase,text_type)
    print2(str(data_value_3(ed_sel_tile)),px_f, py_a*16,    1)
    
    'value 4
    obed_btn(                       px_d,   py_a*18,    1,  12,decrease)
    select case as const data_type(ed_sel_tile)
    case 100:text_type="-"
    case 101 to 100+i_ts3dr_y:text_type="-"
    case 0:text_type="-"
    case 1:text_type="-"
    case 2:text_type="Mana Max"
    case 3:text_type="Hunger"
    case 4:text_type="World Y"
    case 5:text_type="Requires pos"
    case 6:text_type="-"
    case 7:text_type="Text #4":print2(data_strings(data_value_4(ed_sel_tile)),px_f+txt_sp, py_a*18)
    case 8:text_type="Choice #2":print2(data_strings(data_value_4(ed_sel_tile)),px_f+txt_sp, py_a*18)
    case 9:text_type="Dex"
    case 10:text_type="-"
    case 11:text_type="-"
    case 12:text_type="-"
    end select
    obed_btn(                       px_e,   py_a*18,    3,  12,increase,text_type)
    print2(str(data_value_4(ed_sel_tile)),px_f, py_a*18,    1)
    
    'value 5
    obed_btn(                       px_d,   py_a*20,    1,  13,decrease)
    select case as const data_type(ed_sel_tile)
    case 100:text_type="-"
    case 101 to 100+i_ts3dr_y:text_type="-"
    case 0:text_type="-"
    case 1:text_type="-"
    case 2:text_type="XP"
    case 3:text_type="Thirst"
    case 4:text_type="-"
    case 5:text_type="Use Once?"
    case 6:text_type="-"
    case 7:text_type="Text #5":print2(data_strings(data_value_5(ed_sel_tile)),px_f+txt_sp, py_a*20)
    case 8:text_type="Event #1"
    case 9:text_type="-"
    case 10:text_type="-"
    case 11:text_type="-"
    case 12:text_type="-"
    end select
    obed_btn(                       px_e,   py_a*20,    3,  13,increase,text_type)
    print2(str(data_value_5(ed_sel_tile)),px_f, py_a*20,    1)
    
    'value 6
    obed_btn(                       px_d,   py_a*22,    1,  14,decrease)
    select case as const data_type(ed_sel_tile)
    case 100:text_type="-"
    case 101 to 100+i_ts3dr_y:text_type="-"
    case 0:text_type="-"
    case 1:text_type="-"
    case 2:text_type="Money"
    case 3:text_type="-"
    case 4:text_type="-"
    case 5:text_type="Use Event"
    case 6:text_type="-"
    case 7:text_type="Text #6":print2(data_strings(data_value_6(ed_sel_tile)),px_f+txt_sp, py_a*22)
    case 8:text_type="Event #2"
    case 9:text_type="-"
    case 10:text_type="Result"+"   "+str(data_names(data_value_6(ed_sel_tile)))
    case 11:text_type="-"
    case 12:text_type="-"
    end select
    obed_btn(                       px_e,   py_a*22,    3,  14,increase,text_type)
    print2(str(data_value_6(ed_sel_tile)),px_f, py_a*22,    1)
    
    'draw mouse
    if not mouse_x = -1 then'bug preventing - mouse is out of the window
        drawimg(img_mouse(1),mouse_x,mouse_y,3)
    endif
    
end sub

'-------------------------------------------------------------------------------
sub draw_tile_chooser()
    
    'mouse
    getmouse mouse_x,mouse_y,,mouse_button
    
    'bg
    drawimg(img_obed_bg_2x(1))
    drawimg(img_text_frame_editor(1),0,600-24)
    
    dim as short fn, fn_x, fn_y, id_counter
    for fn_y = 0 to 18-1
    for fn_x = 0 to 25-1
        for fn = id_counter to i_mos
            id_counter = id_counter + 1
            if id_counter = i_mos then id_counter = 1'bug prevention
            if data_id(id_counter) > 0 then
                drawimg(img_tiles(data_image(id_counter)),fn_x*i_tss,fn_y*i_tss)
                if data_image(id_counter) = 0 then
                    print2("!",fn_x*i_tss+(i_tss/2),fn_y*i_tss+(i_tss/2)-4,1,9)
                endif
                if mouse_x > fn_x*i_tss and mouse_y > fn_y*i_tss and mouse_x < fn_x*i_tss+i_tss and mouse_y < fn_y*i_tss+i_tss then
                    print2("#"+str(data_id(id_counter))+" "+str(data_names(id_counter)),10,583)
                    color rgb(255,0,0)
                    rect(fn_x*i_tss,fn_y*i_tss,i_tss,i_tss,0)
                    'sort
                    'if mouse_button = 2 then
                    '    if switch_id_a = 0 then
                    '        switch_id_a = id_counter'get a
                    '    endif
                    'elseif switch_id_a <> 0 then
                    '    switch_id_b = id_counter'get b
                    '    data_id(id_counter) = switch_id_a'put a
                    '    data_id(switch_id_a) = switch_id_b'put b
                    '    switch_id_a = 0'reset
                    '    switch_id_b = 0
                    '    data_CSV_write()
                    '    data_CSV_read()
                    'endif
                    'drawimg(img_tiles(data_image(switch_id_a)),mouse_x+i_tss/4,mouse_y+i_tss/4,2,128)
                    if mouse_button = 1 then
                        ed_sel_tile = id_counter
                        engine = 40
                        flush()
                        exit for
                    endif
                endif
                exit for
            else
                exit for'stop repeating objects
            endif
        next
    next
    next
    
    'draw mouse
    if not mouse_x = -1 then'bug preventing - mouse is out of the window
        drawimg(img_mouse(1),mouse_x,mouse_y,3)
    endif
    
end sub

'-------------------------------------------------------------------------------
sub draw_image_chooser()
    
    'mouse
    getmouse mouse_x,mouse_y,,mouse_button
    
    'bg
    drawimg(img_obed_bg_2x(1))
    'drawimg(img_text_frame_editor(1),0,600-24)
    
    dim as short fn, fn_x, fn_y, id_counter
    for fn_y = 0 to 18-1
    for fn_x = 0 to 25-1
        for fn = id_counter to i_mds -1'bug - too large array
            id_counter = id_counter + 1
            'if data_id(id_counter) > 0 then
                drawimg(img_tiles(id_counter),fn_x*i_tss,fn_y*i_tss)
                if mouse_x > fn_x*i_tss and mouse_y > fn_y*i_tss and mouse_x < fn_x*i_tss+i_tss and mouse_y < fn_y*i_tss+i_tss then
                    color rgb(255,0,0)
                    rect(fn_x*i_tss,fn_y*i_tss,i_tss,i_tss,0)
                    if mouse_button = 1 then
                        data_image(ed_sel_tile) = id_counter
                        engine = 40
                        flush()
                        exit for
                    endif
                endif
                exit for
            'endif
        next
    next
    next
    
    'draw mouse
    if not mouse_x = -1 then'bug preventing - mouse is out of the window
        drawimg(img_mouse(1),mouse_x,mouse_y,3)
    endif
    
end sub
