declare sub loading()

'-------------------------------------------------------------------------------
sub loading()
    
    'scaling of screen
    img_screen          = imagecreate(sc_x_game_def     ,sc_y_game_def)
    img_screen_scale    = imagecreate(sc_x_game_def * 2 ,sc_y_game_def * 2)
    
    if sc_intro = true then
    'load screen
    chdir("GFX")
        chdir("GUI")
            loadimg(img_freebasic(),"freebasic.png")
            screenlock
            drawimg(img_freebasic(1))
            if sc_scale then scale_screen()
            screenunlock
            sleep 500,1
        chdir("..")
    chdir("..")
    
    chdir("SFX")
        chdir("interface")
            loadsnd(snd_freebasic,"freebasic.wav")
            playsnd(snd_freebasic)
            sleep 2000,1
            locate 2,2:inc(1):print "Loading..."
        chdir("..")
    chdir("..")
    endif
    
    'loading
    chdir("GFX")
        
        chdir("MAP")
            loadtile(img_tiles(),"tiles.png",i_tsr,i_tss)
            loadtile(img_tiles_3d(),"tiles_3d.png",i_ts3dr_x,i_dis_x,i_ts3dr_y,i_dis_y)
        chdir("..")
        
        chdir("GUI")
            loadimg(img_font(),"font.png",8,9,254)
            loadimg(img_gui(),"gui.png")
            loadimg(img_gui_death(),"gui_death.png")
            loadimg(img_enemy_hp_bar(),"enemy_hp_bar.png")
            loadimg(img_bagpack(),"bagpack.png")
            loadimg(img_bcur(),"bcur.png")
            loadimg(img_choice(),"choice.png")
            loadimg(img_compass(),"compass.png",18,15,4)
            loadimg(img_hit(),"hit.png")
            loadimg(img_slice(),"slice.png")
            loadimg(img_menu_bg(),"menu_bg.png")
            loadimg(img_menu_1(),"menu_1.png")
            loadimg(img_menu_2(),"menu_2.png")
            loadimg(img_menu_3(),"menu_3.png")
            loadimg(img_menu_cursor(),"menu_cursor.png")
            loadimg(img_mini_map(),"mini_map.png")
            loadimg(img_mouse(),"mouse.png")
            loadimg(img_block(),"block.png",32,32,7)
            loadimg(img_obed_btns(),"obed_btns.png",12,12,9)
            loadimg(img_obed_bg(),"obed_bg.png")
            scale(img_obed_bg(),img_obed_bg_2x(),400,300,2)
            loadimg(img_obed_mouse(),"obed_mouse.png")
            loadimg(img_text_frame(),"text_frame.png")
            loadimg(img_text_frame_editor(),"text_frame_editor.png")
            loadimg(img_world_map(),"world_map.png")
        chdir("..")
        
    chdir("..")
    
    chdir("SFX")
        'effects
        chdir("effects")
            dim as ubyte fn
            for fn = 0 to max_sfx'fill pointer with blank sounds
                loadsnd(snd_fx(fn),"00_nothing.wav")
            next
            loadsnd(snd_fx(1 ),"01_door_open.wav")
            loadsnd(snd_fx(2 ),"02_door_close.wav")
            loadsnd(snd_fx(3 ),"03_cavewind.wav")
            loadsnd(snd_fx(4 ),"04_resurrect.wav")
            loadsnd(snd_fx(5 ),"05_healing.mp3")
            loadsnd(snd_fx(6 ),"06_secret.mp3")
            loadsnd(snd_fx(7 ),"07_teleport.wav")
            loadsnd(snd_fx(8 ),"08_mecanism.wav")
            loadsnd(snd_fx(9 ),"09_lever.wav")
            loadsnd(snd_fx(10),"10_rat.wav")
            loadsnd(snd_fx(11),"11_rocks_fall.wav")
            loadsnd(snd_fx(12),"12_rocks_fall_2.wav")
            loadsnd(snd_fx(13),"13_rocks_fall_3.wav")
            loadsnd(snd_fx(14),"14_rocks_fall_4.wav")
            loadsnd(snd_fx(15),"15_paper.wav")
            loadsnd(snd_fx(16),"16_monkey.wav")
            loadsnd(snd_fx(17),"17_jones.ogg")
            loadsnd(snd_fx(18),"18_explode.wav")
            loadsnd(snd_fx(19),"19_smoking.wav")
            loadsnd(snd_fx(20),"20_lock.wav")
            loadsnd(snd_fx(21),"21_gate.wav")
            loadsnd(snd_fx(22),"22_rapier.wav")
            loadsnd(snd_fx(23),"23_bear.wav")
            loadsnd(snd_fx(24),"24_coins.wav")
        chdir("..")
    
        'interface
        chdir("interface")
            loadsnd(snd_backspace,"backspace.wav")
            loadsnd(snd_combine,"combine.wav")
            loadsnd(snd_death,"death.wav")
            loadsnd(snd_escape,"escape.wav")
            loadsnd(snd_fight_die,"fight_die.wav")
            loadsnd(snd_fight_hit,"fight_hit.wav")
            loadsnd(snd_fight_miss,"fight_miss.wav")
            loadsnd(snd_fight_pain,"fight_pain.wav")
            loadsnd(snd_item,"item.wav")
            loadsnd(snd_level_up,"level_up.wav")
            loadsnd(snd_menu_enter,"menu_enter.wav")
            loadsnd(snd_menu_scroll,"menu_scroll.wav")
        chdir("..")
        
        'stream
        chdir("stream")
            loadstr(str_menu,"str_menu.mp3")
            loadstr(str_music(1),"str_1.ogg")
            loadstr(str_music(2),"str_2.ogg")
            loadstr(str_music(3),"str_3.ogg")
            loadstr(str_music(4),"str_4.ogg")
            loadstr(str_music(5),"str_5.ogg")
            loadstr(str_music(6),"str_6.ogg")
        chdir("..")
    chdir("..")
    
    'scaling of floor objects
    scale(img_tiles(),img_tiles_1x0c5x(),i_tss,i_tss,1,1,2,i_mds)
    scale(img_tiles(),img_tiles_2x1x(),i_tss,i_tss,0,2,1,i_mds)
    scale(img_tiles(),img_tiles_5x2x(),i_tss,i_tss,0,4,2,i_mds)
    'scaling of room objects
    scale(img_tiles(),img_tiles_2x(),i_tss,i_tss,0,2,2,i_mds)
    scale(img_tiles(),img_tiles_5x(),i_tss,i_tss,0,5,5,i_mds)
    
    'start menu
    engine = 2
    playstr(str_menu)
    
end sub
