    'sfx
    if data_sfx(map(x,y)) > 0 and data_type(map(x,y)) <> 9 and draw_msg = false then'if not an enemy
        if data_sfx(map(x,y)) > 100 then
            playstr(str_music( data_sfx(map(x,y))-100 ))
        else
            playsnd(snd_fx( data_sfx(map(x,y)) ))
        endif
    endif
    
    'wait before event
    if data_wait(map(x,y)) > 0 then
        screenlock
        if pl_hp > 0 then
            draw_map3d()
            if sc_scale then scale_screen()
        elseif pl_hp = 0 then
            draw_map2d()
            if sc_scale then scale_screen()
        endif
        screenunlock
        sleep (data_wait(map(x,y)) * 100),1
    endif
    
    'events selected by types
    select case as const data_type(map(x,y))
    
    case 0'decor
        after_event()
    
    case 1'replace_field_remote
        'replace remote position with new value
        if data_value_1(map(x,y)) > 0 and data_value_2(map(x,y)) > 0 and data_value_3(map(x,y)) > 0 then
            map(data_value_2(map(x,y)),data_value_3(map(x,y))) = data_value_1(map(x,y))
        'replace remote position with map default
        elseif data_value_1(map(x,y)) = 0 and data_value_2(map(x,y)) > 0 and data_value_3(map(x,y)) > 0 then
            map(data_value_2(map(x,y)),data_value_3(map(x,y))) = map_type
        'replace player position with new value
        elseif data_value_1(map(x,y)) > 0 and data_value_2(map(x,y)) = 0 and data_value_3(map(x,y)) = 0 then
            map(x,y) = data_value_1(map(x,y))
        'replace player position with map default
        elseif data_value_1(map(x,y)) = 0 and data_value_2(map(x,y)) = 0 and data_value_3(map(x,y)) = 0 then
            map(x,y) = map_type
        endif
        after_event()
        
    case 2'change_status
        pl_hp       = pl_hp     + data_value_1(map(x,y))
        if data_value_1(map(x,y)) < 0 then playsnd(snd_fight_pain)
        pl_hp_max   = pl_hp_max + data_value_2(map(x,y))
        pl_ma       = pl_ma     + data_value_3(map(x,y))
        pl_ma_max   = pl_ma_max + data_value_4(map(x,y))
        pl_xp       = pl_xp     + data_value_5(map(x,y))
        pl_money    = pl_money  + data_value_6(map(x,y))
        after_event()
        
    case 3'change_status_b
        pl_str      = pl_str    + data_value_1(map(x,y))
        pl_def      = pl_def    + data_value_2(map(x,y))
        pl_dex      = pl_dex    + data_value_3(map(x,y))
        pl_hu       = pl_hu     + (data_value_4(map(x,y)) * 10)
        pl_th       = pl_th     + (data_value_5(map(x,y)) * 10)
        after_event()
        
    case 4'teleport
        dim as short x_temp = x, y_temp = y'bug prevention
        'local map
        if data_value_3(map(x,y)) = 0 and data_value_4(map(x,y)) = 0 then
            x = data_value_1(map(x_temp,y_temp))
            y = data_value_2(map(x_temp,y_temp))
            'after event
            if data_post(map(x_temp,y_temp)) > 0 then map(x_temp,y_temp) = data_post(map(x_temp,y_temp))
        'load new map
        elseif data_value_3(map(x,y)) > 0 and data_value_4(map(x,y)) > 0 then
            'save last map & save status
            data_SAVE_write()
            data_SAVE_MAP_write()
            'load new map
            world_x = data_value_3(map(x,y))
            world_y = data_value_4(map(x,y))
            'sets position on new map
            x = data_value_1(map(x_temp,y_temp))
            Y = data_value_2(map(x_temp,y_temp))
            'checks if the new map has been visited
            chdir("Save")
            file_map_save(world_x,world_y)=freefile
            if open(file_map_save_path(world_x,world_y) for input as #file_map_save(world_x,world_y)) = 0 then
                close:chdir("..")
                data_SAVE_MAP_read()
            elseif open(file_map_save_path(world_x,world_y) for input as #file_map_save(world_x,world_y)) > 0 then
                close:chdir("..")
                data_MAP_read()
            endif
        endif
        
    case 5'get_item
        dim as ubyte fn_x, fn_y
        for fn_y = 1 to itm_y_max
            for fn_x = 1 to itm_x_max - 3'bug prevention - picking up to wrong place
                if itm(fn_x,fn_y) = 0 then
                    itm(fn_x,fn_y) = map(x,y)
                    playsnd(snd_item)
                    exit for, for
                endif
            next
        next
        after_event()
        
    case 6'del item from bag
        dim as ubyte fn_x, fn_y
        for fn_y = 1 to itm_y_max
            for fn_x = 1 to itm_x_max
                if itm(fn_x,fn_y) = data_value_1(map(x,y)) then
                    itm(fn_x,fn_y) = 0
                    exit for, for
                elseif itm_sel = data_value_1(map(x,y)) then
                    itm_sel = 0
                    exit for, for
                endif
            next
        next
        after_event()
    
    case 7'message
        if draw_msg = false then
            draw_msg = true
        elseif draw_msg = true then
            if key_enter = true then
                draw_msg = false
                after_event()
            endif
        endif
        
    case 8'choice
        'hit enter first time
        if draw_msg = false then
            draw_msg = true
            choice = 1
        'hit enter second time
        elseif draw_msg = true then
            if key_enter = true then
                draw_msg = false
                select case as const choice
                case 1
                    choice = 0
                    map(x,y) = data_value_5(map(x,y))
                case 2
                    choice = 0
                    map(x,y) = data_value_6(map(x,y))
                end select
            endif
        endif
     
    case 9'fight
        'start fight
        if fight_round = 0 then
            fight_round = 1
            fight_anim = 0
            auto_play = true
        endif
        select case as const fight_round
        'player attacks
        case 1
            pl_atk = ( rnd * pl_dex + (data_value_4(map(x,y)) / 3) ) + 1
            en_atk = ( rnd * data_value_4(map(x,y))                ) + 1
            if pl_atk > en_atk then
                if pl_str > data_value_3(map(x,y)) then
                    en_hp(x,y) = en_hp(x,y) - pl_str + data_value_3(map(x,y))
                elseif pl_str <= data_value_3(map(x,y)) then
                    en_hp(x,y) = en_hp(x,y) - 1
                endif
                playsnd(snd_fx( data_sfx(itm(11,2)) ))'weapon effect
                playsnd(snd_fight_hit)
                fight_anim = 1
            else
                playsnd(snd_fight_miss)
                fight_anim = 2
            endif
            fight_round = 2
            'enemy dies
            if en_hp(x,y) <= 0 then
                fight_round = 0
                fight_anim = 0
                auto_play = false
                en_hp(x,y) = 0'reset
                pl_xp = pl_xp + data_value_1(map(x,y)) + data_value_2(map(x,y)) + data_value_3(map(x,y)) + data_value_4(map(x,y))
                pl_ma = pl_ma + 10
                playsnd(snd_fight_die)
                after_event()
            endif
        'enemy attacks
        case 2
            pl_atk = ( rnd * pl_dex                                ) + 1
            en_atk = ( rnd * data_value_4(map(x,y)) + (pl_dex / 3) ) + 1
            if en_atk > pl_atk then
                if data_value_2(map(x,y)) > pl_def then
                    pl_hp = pl_hp - data_value_2(map(x,y)) + pl_def
                elseif data_value_2(map(x,y)) <= pl_def then
                    pl_hp = pl_hp - 1
                endif
                playsnd(snd_fx( data_sfx(map(x,y)) ) )'enemy attacks
                playsnd(snd_fight_pain)
                fight_anim = 3
            else
                playsnd(snd_fight_miss)
                fight_anim = 4
            endif
            fight_round = 3
            'player dies
            if pl_hp <= 0 then
                fight_round = 0
                fight_anim = 0
                auto_play = false
            endif
        'end round
        case 3
            fight_round = 0
            fight_anim = 0
            auto_play = false
        end select
        
    case 11'get mini map
        mini_map(data_value_2(map(x,y)),data_value_3(map(x,y))) = data_value_1(map(x,y))
        after_event()
        
    case 12'get compass
        draw_compass = data_value_1(map(x,y))
        after_event()
        
    end select
