'###_CREDITES_##################################################################
'Witchcraft Options
'2011 by N3trunn3r
'http://catbone.freebasic.net/
'written for FreeBASIC version 0.21.1

'###_LIBS_######################################################################
'gfx, sfx, input
#include once "n3trunn3r/speedgui.bas"

'###_VALUES_####################################################################
'game relate
dim shared as byte      sc_full = 0
dim shared as byte      sc_intro = 1
dim shared as byte      sc_filter = 2
dim shared as byte      sc_driver = 1
dim shared as byte      feedback = 0

'configuration
dim shared as integer   file_cfg
dim shared as string    file_cfg_path:file_cfg_path="Witchcraft.cfg"

'combo box
sgui_co_itm(1) = 4'max items in a combo box
sgui_co_grp(1,1) = "320 x 240"
sgui_co_grp(1,2) = "640 x 480"
sgui_co_grp(1,3) = "640 x 480 eagle"
sgui_co_grp(1,4) = "640 x 480 eagle alt"

'images
dim shared as any ptr img_options(1)

'###_FUNCTIONS_#################################################################
declare sub data_CFG_read()
declare sub data_CFG_write()

'-------------------------------------------------------------------------------
sub sgui_action(sgui_id as short)
    
    select case as const sgui_id
    case 1:sc_driver = 1 'group id
    case 2:sc_driver = 2 'group id
    case 3:sc_driver = 3 'group id
    case 4:sc_full   = sgui_ch(4) 'event id
    case 5:sc_intro  = sgui_ch(5) 'event id
    case 6:sc_filter = sgui_co_itm_sel(1) 'group id
    case 7:feedback = sgui_ch(7) 'group id
    end select
    
    data_CFG_write()
    
end sub

'-------------------------------------------------------------------------------
sub data_CFG_read()
    
    'if there is no file create one
    file_cfg=freefile
    if open(file_cfg_path for input as #file_cfg) = 2 then
        data_CFG_write()
    endif
    
    'check for more read errors
    file_cfg=freefile
    if open(file_cfg_path for input as #file_cfg) > 0 then
        cls:print "Read Error":sleep:end
    endif
    
    'read cfg
    file_cfg=freefile
    open file_cfg_path for input as #file_cfg
        input #file_cfg, _
            sc_full, sc_intro, sc_filter, sc_driver, feedback
    close
    
    'set configuration
    sgui_ch(4)          = sc_full 'event id
    sgui_ch(5)          = sc_intro 'event id
    sgui_ch(7)          = feedback 'event id
    sgui_co_itm_sel(1)  = sc_filter 'group id
    sgui_ra_grp(1)      = sc_driver 'group id
    
end sub

'-------------------------------------------------------------------------------
sub data_CFG_write()
    
    'check for write errors
    file_cfg=freefile
    if open(file_cfg_path for output as #file_cfg) > 0 then
        cls:print "Write Error":sleep:end
    endif
    
    'erase old file
    kill file_cfg_path
    
    'write cfg
    file_cfg=freefile
    open file_cfg_path for output as #file_cfg
        write #file_cfg, _
            sc_full, sc_intro, sc_filter, sc_driver, feedback
    close
    
end sub

'###_INIT_######################################################################
windowtitle "Options"
screen 14,32,,&h04'disable fullscreen
initsgui()
chdir("GFX"):loadimg (img_options(1),"options.png"):chdir("..")
data_CFG_read()

'###_MAIN_LOOP_#################################################################
do
    
    screenlock
    cls
    mouse()
    sgui_bg()
    drawimg(img_options(1))
    
    font("Graphics Driver",20,70)
    sgui_radio(20,80,   1   ,1,"DirectX")
    sgui_radio(20,100,  2   ,1,"GDI")
    sgui_radio(20,120,  3   ,1,"OpenGL")
    
    sgui_check(160,120, 4   ,"Fullscreen")
    sgui_check(160,140, 5   ,"FreeBASIC Logo")
    sgui_check(160,160, 7   ,"Feedback URL")
    
    font("Screen Resolution",160,70)
    sgui_combo(160,80,  6   ,1,140)
    
    screenunlock
    sleep 20,1
    
loop until multikey(fb.sc_escape) or inkey = Chr(255)&"k"
