defdbl a-z
'$include: 'fbgfx.bi'

screenres 320, 240, 32, , 1

const pi = 3.141593
const maxstars = 1
const size = 1
const diminish = 10

type starT
	r as integer
	g as integer
	b as integer
end type

dim randoms(320, 240) as double
randomize timer

redim star(0 to 319, 0 to 239) as starT

for i = 1 to maxstars
	
	ang = rnd*2*pi
	dist = (rnd^2)*size/2*0.65
	
	x% = (size/2)+cos(ang)*dist
	y% = (size/2)+sin(ang)*dist

	dim as starT ns

	r% = fix(rnd*2.9999)

	if r% = 0 then

		ns.r = 255: ns.g = 255: ns.b = 255

	elseif r% = 1 then

		ns.r = 0: ns.g = 0: ns.b = 255

	elseif r% = 2 then

		ns.r = 255: ns.g = 0: ns.b = 0

	end if

	fac = rnd^2

	ns.r *= fac
	ns.g *= fac
	ns.b *= fac

	star(x%, y%) = ns

next i

dim as integer xx, yy

for x = 0 to size-1
	for y = 0 to size-1

		ir = 0
		ig = 0
		ib = 0

		for xx = x-15 to x+15
			for yy = y-15 to y+15

				if xx >= 0 and yy >=0 and xx < 320 and yy < 240 then

					dist = sqr(((x-xx)^2 + (y-yy)^2)+1) * diminish ^ 1.2
					ir += star(xx, yy).r / dist
					ig += star(xx, yy).g / dist
					ib += star(xx, yy).b / dist
				
				end if
			
			next yy
		next xx

		if multikey(SC_ESCAPE) then end

		if ir > 255 then ir = 255
		if ig > 255 then ig = 255
		if ib > 255 then ib = 255

		pset (x, y), rgb(ir, ig, ib)
	
	next y
next x

dim as integer ptr result = imageCreate(size, size)
get (0, 0)-(size-1, size-1), result

dim as string filename

filename = "star" + ltrim$(str$(fix(timer) mod 1000)) + ".bsv"
bsave filename, result, (size*size+1)*4

imageDestroy result

while not multikey(SC_ESCAPE): wend
