#version 130
uniform sampler2D texture;
in vec4 texCoord;
in vec4 colordata;

void main(void) {

	vec4 color = texture2D(texture, texCoord.st);
	if (color[3] == 0.0) discard; // le discard
	
	color.rgb = mix(color.rgb, colordata.rgb, colordata.a);
	
	gl_FragColor = color;

}
